#################################################################################
# Created       : Martin Foster
# Modified      : 03/02/2001
#################################################################################
#
# Filter - A filtering system that allows for safer handling of posts  
# Copyright (C) 2000-2001  Martin Foster
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Author of this script can be contacted at the following:
#       E-Mail  : mfoster@redwhite.com
#       Address : Suite 209 - 355 5th Ave NE
#                 Calgary, Alberta
#                 T2E 0K9
#
#################################################################################

package Webchat::Filter;

#################################################################################
# Sub-Routines
#################################################################################

#####################
# SafeHTML 
#
# While the name may be slightly misleading as the HTML can still be malicious to a degree
# this subroutine will aim to make it safer.   Note however, that the only safe HTML is no
# HTML.

sub SafeHTML 	 						# String to handle 
{
	#####################
	# Data members

	my $str     = shift;					# String name


	#####################
	# Program area
        # Title filters

	# Comments
	$str =~ s/<!-|-->|<COMMENT>|<\/COMMENT>//gsi;

	# Standard filtering 
	$str =~ s/<APPLET.*?>|<\/APPLET>|<BODY.*?>|<\/BODY>|<BGSOUND>|<EMBED.*?>|<\/EMBED>|<FORM.*?>|<\/FORM>//gsi;
	$str =~ s/<HTML.*?>|<\/HTML>|<IMG.*?>|<TABLE.*?>|<\/TABLE>|<TITLE.*?>|<\/TITLE>//gsi;

	# Close tags
	while ($str =~ m/<(\w.*?)(\s|>)/gs)
	{
		# Skips
		next if ($1 =~ /^BR/i);
		next if ($1 =~ /^IMG/i);

		# Close tags
		if ($str !~ /<\/$1>/i) { $str = "$str<\/$1>"; }
	}

	# Return
	return $str;
}

1;								# Return true
